给定一个数组,它的第 i 个元素是一支给定股票第 i 天的价格。
设计一个算法来计算你所能获取的最大利润。你可以尽可能地完成更多的交易(多次买卖一支股票)。
注意:你不能同时参与多笔交易(你必须在再次购买前出售掉之前的股票)。
示例 1:
输入: [7,1,5,3,6,4]
输出: 7
解释: 在第 2 天(股票价格 = 1)的时候买入,在第 3 天(股票价格 = 5)的时候卖出, 这笔交易所能获得利润 = 5-1 = 4 。随后,在第 4 天(股票价格 = 3)的时候买入,在第 5 天(股票价格 = 6)的时候卖出, 这笔交易所能获得利润 = 6-3 = 3 。
示例 2:
输入: [1,2,3,4,5]
输出: 4
解释: 在第 1 天(股票价格 = 1)的时候买入,在第 5 天 (股票价格 = 5)的时候卖出, 这笔交易所能获得利润 = 5-1 = 4 。注意你不能在第 1 天和第 2 天接连购买股票,之后再将它们卖出。因为这样属于同时参与了多笔交易,你必须在再次购买前出售掉之前的股票。
示例 3:
输入: [7,6,4,3,1]
输出: 0
解释: 在这种情况下, 没有交易完成, 所以最大利润为 0。
LeetCode 链接
class Solution:
def maxProfit(self, prices):
if not prices:
return 0
res = 0 # 初始化利润
for i in range(len(prices)-1):
res += max(0, prices[i+1]-prices[i]) # 若股票价格上升,则叠加利润
return res
test = Solution()
prices_li = [[7,1,5,3,6,4],
[1,2,3,4,5],
[7,6,4,3,1]
]
for prices in prices_li:
print(test.maxProfit(prices))
7
4
0
状态转移方程:
dp[i][k][0] = max(dp[i-1][k][0], dp[i-1][k][1] + prices[i])
max( 选择 rest , 选择 sell )
dp[i][k][1] = max(dp[i-1][k][1], dp[i-1][k-1][0] - prices[i])
max( 选择 rest , 选择 buy )
本题交易次数 K=无穷大
,即交易多少次皆可,进而分析之前进行交易的次数不影响当前状态选择,因此简化 k
后的状态转移方程如下:
dp[i][0] = max(dp[i-1][0], dp[i-1][1] + prices[i])
dp[i][1] = max(dp[i-1][1], dp[i-1][0] - prices[i])
class Solution:
def maxProfit(self, prices):
if not prices:
return 0
dp_i_0, dp_i_1 = 0, float('-inf')
for i in range(len(prices)):
temp = dp_i_0
dp_i_0 = max(dp_i_0, dp_i_1 + prices[i])
dp_i_1 = max(dp_i_1, temp - prices[i])
return dp_i_0
test = Solution()
prices_li = [[7,1,5,3,6,4],
[1,2,3,4,5],
[7,6,4,3,1]
]
for prices in prices_li:
print(test.maxProfit(prices))
7
4
0
说明:上述代码为将 dp
数组简化为单变量的方式,具体过程建议查看 CSDN 博客。
LeetCode:121. 买卖股票的最佳时机(python)
LeetCode:122. 买卖股票的最佳时机 II(python)
LeetCode:123. 买卖股票的最佳时机 III(python)
LeetCode:188. 买卖股票的最佳时机 IV(python)
LeetCode:309. 最佳买卖股票时机含冷冻期(python)
LeetCode:714. 买卖股票的最佳时机含手续费(python)
LeetCode 题解